//+------------------------------------------------------------------+
//|                                                       Ichi_2.mq5 |
//|                                                            Graff |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Graff"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//--- input parameters
input int      TenkanSen=9;
input int      KijunSen=26;
input int      SenkoSpan=52;
//uint ichi_h=0;
#include <Indicators\Trend.mqh>
CiIchimoku ichi;
uint ichi_h=0;

#include <ChartObjects\ChartObjectsArrows.mqh>
CChartObjectArrowDown down;
CChartObjectArrowUp up;

string prefix="Ich1_";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   ichi.Create(_Symbol,_Period,TenkanSen,KijunSen,SenkoSpan);
   ichi.BufferResize(TerminalInfoInteger(TERMINAL_MAXBARS));
//---
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   DeleteObjectPrefix(prefix);
   Comment("");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   ichi.Refresh(-1);
//Comment("Span A:"+DoubleToString(ichi.SenkouSpanA(0),5)+" Span B:"+DoubleToString(ichi.SenkouSpanB(0),5)+" Tenkan:"+DoubleToString(ichi.TenkanSen(0),5)+" Kijun:"+DoubleToString(ichi.KijunSen(0),5));
/**/
   for(int i=0;i<rates_total;i++) // Main loop http://www.kumotrader.com/ichimoku_wiki/index.php?title=Ichimoku_trading_strategies#Kijun_Sen_Cross
     {
      if((ichi.TenkanSen(i)>ichi.SenkouSpanA(i)) && (ichi.TenkanSen(i)>ichi.SenkouSpanB(i)) && (ichi.KijunSen(i)>ichi.SenkouSpanA(i)) && (ichi.KijunSen(i)>ichi.SenkouSpanB(i))) // Tenkan and Kijun above cloude
        {
         if(ichi.TenkanSen(i)>ichi.KijunSen(i))//A strong tenkan sen/kijun sen cross Buy signal takes place when a bullish cross happens above the kumo.  
           {
            up.Create(0,prefix+IntegerToString(i),0,time[i],low[i]);
            up.Color(clrLimeGreen);
           }
        }
      if((ichi.TenkanSen(i)<ichi.SenkouSpanA(i)) && (ichi.TenkanSen(i)<ichi.SenkouSpanB(i)) && (ichi.KijunSen(i)<ichi.SenkouSpanA(i)) && (ichi.KijunSen(i)<ichi.SenkouSpanB(i))) // Tenkan and Kijun below cloude
        {
         if(ichi.TenkanSen(i)<ichi.KijunSen(i))//A strong tenkan sen/kijun sen cross Sell signal takes place when a bearish cross happens below the kumo. 
           {
            down.Create(0,prefix+IntegerToString(i),0,time[i],low[i]);
            down.Color(clrTomato);
           }
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
void DeleteObjectPrefix(string pref)
  {
   int i=0;
   string objname;
   for(i=ObjectsTotal(0,0,-1)-1; i>=0; i--)
      //+------------------------------------------------------------------+
      //|                                                                  |
      //+------------------------------------------------------------------+
     {
      objname=ObjectName(0,i);
      if(StringFind(objname,pref)==-1) continue;
      else ObjectDelete(0,objname);
     }
  }
//+------------------------------------------------------------------+
